Subject: bug#37897: Bug: Resetting locale settings

From: [email-masked]
Date: Thu, 14 Nov 2019 13:23:13 +0100

Hello ludo, hey guys,

here you go. I took the liberty to anonymize and to skip the package 
modules and packages sections.

I realised that when I dont specify WHICH KIND of german keyboard layout 
I have, the problem does not occur. That is, if I use the 
(keyboard-layout (keyboard-layout "de")), I dont have any problems.

Thus I suppose that there might be something wrong with the spelling of 
the specification (compare both commented-out attempts at 
specification). Strictly speaking, then, it may not be a bug. But if it 
is not a bug, I dont know how specify the specification, since in the 
manual the specification consists of only one word (e.g. "fr" "bepo"), 
and under /run/current-system/profile/share/keymaps/i386/qwertz/, said 
keymap is listed as "de-latin1-nodeadkeys".

(use-modules (gnu))
(use-service-modules desktop networking ssh xorg)
(use-package-modules ...)

(operating-system
   (locale "de_DE.utf8")
   (timezone "Europe/Berlin")
;;  (keyboard-layout (keyboard-layout "de" "latin1-nodeadkeys"))
;;  (keyboard-layout (keyboard-layout "de" "latin1 nodeadkeys"))
   (keyboard-layout (keyboard-layout "de"))
   (bootloader
     (bootloader-configuration
       (bootloader grub-bootloader)
       (target "/dev/sdb")
       (keyboard-layout keyboard-layout)))
   (swap-devices (list "/dev/sdb3"))
   (file-systems
     (cons* (file-system
              (mount-point "/home")
              (device
                (uuid "8ee0b983-53f0-4e18-852f-8cd4424a6c6f"
                      'btrfs))
              (type "btrfs"))
            (file-system
              (mount-point "/")
              (device
                (uuid "cb425a5f-bd91-45d3-92e1-3b983450ee21"
                      'ext4))
              (type "ext4"))
            %base-file-systems))
   (host-name "guixter")
   (users (cons* (user-account
                   (name "user")
                   (comment "")
                   (group "users")
                   (home-directory "/home/user")
                   (supplementary-groups
                     '("wheel" "netdev" "audio" "video")))
                 %base-user-accounts))
   (packages
     (append
      (list ...)
       %base-packages))
   (services
     (append
       (list (service xfce-desktop-service-type)
             (set-xorg-configuration
               (xorg-configuration
                 (keyboard-layout keyboard-layout))))
       %desktop-services)))

Greetings,
Olivier

On 13.11.2019 14:48, Ludovic Courtès wrote:
> Hi,
> 
> [email-masked] skribis:
> 
>> So I was talking about the keyboard layout all along. Not only was my
>> locale set to "de_DE.utf8", but my keyboard configuration is set to
>> "de-latin1-nodeadkeys". Interestingly, the keyboard layout is
>> different in xorg and xfce than it is in the console (the one I reach
>> via C-M-Fx, not the terminal emulator). In the console, I have the
>> qwertz keyboard layout.
>> 
>> Also find the part of my current configuration file (sitting at
>> /etc/config.scm) which specifies both locale and keyboard layout:
>> (operating-system
>>   (locale "de_DE.utf8")
>>   (timezone "Europe/Berlin")
>>   (keyboard-layout (keyboard-layout "de" "latin1-nodeadkeys"))
>>   (bootloader
>>     (bootloader-configuration
>>       (bootloader grub-bootloader)
>>       (target "/dev/sdb")
>>       (keyboard-layout keyboard-layout)))
> 
> Could you post your complete config file?
> 
> The snippet above defines the keyboard layout for the console and for
> GRUB, but it does not define the keyboard layout for Xorg/Xfce.  For
> that you need an extra bit with ‘set-xorg-configuration’ as noted at
> <>.
> 
> Thanks in advance,
> Ludo’.